/*----------------------------------------------------------
 * controller.js
 * author Ryuto Kurokawa
 * 
 *----------------------------------------------------------*/
$(function(){

/*---------------------- UA判別処理 ----------------------*/

	//スマートフォン以外からのアクセスへのメッセージ表示
	if(navigator.userAgent.indexOf("iPhone") === -1 && navigator.userAgent.indexOf("Android") === -1) {
		$("#messagePC").fadeIn(300).find(".bt_close").click(function(){
			$("#messagePC").fadeOut(300);
		});
	//iPhoneからのアクセスの場合はフルスクリーンモードでの使用を促すメッセージ表示
	} else if(navigator.userAgent.indexOf("iPhone") != -1 && !window.navigator.standalone)  {
		$("#messageFullScreen").fadeIn(300).find(".bt_close").click(function(){
			$("#messageFullScreen").fadeOut(300);
		});
	}
	

/*---------------------- widget slideView ----------------------*/
	//slideView ウィジェットの適用
	$slideView = $("#record").slideView();
 
	//slideView 用 next/backボタンイベント
	$(".ui-slideView-next").bind("click",function(){
		$slideView.slideView("nextView");
	});
	$(".ui-slideView-back").bind("click",function(){
		$slideView.slideView("backView");
	});

	//保存されたレコードの一覧リストは保存/削除されて頻繁にDOMの数が変わるので、
	//bind ではなく live を使ってイベントハンドラを設定
	$(".ui-showRecord-list").live("click",function(){
		$slideView.slideView("nextView");
	});
 
	//スライドのアニメーション終了時によばれるカスタムイベントに対して処理を記述
	$slideView.bind("slide.animate_end",function(e,data){
		switch(data){
			case 0:
				initShowRecordList()
			break;
			case 1:
				$showRecord.showRecord("showRecordDetails");
			break;
			case 2:
				$showRecord.showRecord("showRecordMap");
				adjustElementHeight();
			break;
		}
	});

	//保存されたレコードのリストを生成
	function initShowRecordList(){
		$showRecord.showRecord("showRecordList");
		$("#record section:eq(1) .ui-slideView-back").css("display","block");		
	}



/*---------------------- widget tab ----------------------*/
	//slideView ウィジェットの適用とoptionの設定
	//タブメニューで切り替えたいDOM要素のセレクタを渡す
	var options_tab = {
		contents: [
			"#about",
			"#run",
			"#record"
		],
		current:1 //初期表示したいDOMを指定
	}
	var $tab = $("#ui-tab").tab(options_tab);
 

	//タブ表示切替終了時によばれるカスタムイベントに対して処理を記述
	$tab.bind("tab.changed",function(e,data){
		switch(data.flg){
			case 0:

			break;
			case 1:

			break;
			case 2:
				$slideView.slideView("jumpView",0);
				adjustElementHeight();
				initShowRecordList()
				$slideView.slideView("refresh");
				break;
		}
	});

	//recordのタブ表示中かつslideViewの表示コンテンツが詳細かマップの時に
	//recordのタブをクリックされた場合はrecordのリストに飛ぶ処理
	$("#ui-tabBt_3").click(function(){
		if($slideView.slideView("option","currentPosition") == 0)return;

		$slideView.slideView("jumpView",0);
		initShowRecordList()
	});
 




/*---------------------- widget lockView ----------------------*/
	//slideView ウィジェットの適用とoptionの設定
	//ロック画面の上部タイトルのテキストと、
	//ロックを解除するボタンの横に表示するテキストを設定
	var options_lock = {
		title: "Now Running...",
		buttonText: "Running Exit"
	};
	var $lockView = $("#ui-lockView").lockView(options_lock);
 
	//ロック開始処理をイベントハンドラで設定
	$("#startBt").click(function(){
		$lockView.lockView("lock");
	});
 
	//ロック開始のアニメーション終了時によばれるカスタムイベントに対して処理を記述
	$lockView.bind("lock.locked",function(){
		//走行結果を表示させるrecordタブのレコード詳細画面をロック画面の下で表示させておく
		$tab.tab("setCurrent",2);
		$slideView.slideView("jumpView",1);
		//位置情報取得開始
		Geolocation.start();
	});
 
	//ロック解除のアニメーション終了時によばれるカスタムイベントに対して処理を記述
	$lockView.bind("lock.opened",function(){
		//位置情報取得終了と返り値のデータを取得
		var result = Geolocation.stop();

		//取得したデータを使って詳細を表示
		$showRecord.showRecord("showResultDetails",result);
		$("#record section:eq(1) .ui-slideView-back").css("display","none");		
		
	});
 




/*---------------------- widget showRecord ----------------------*/
	//slideView ウィジェットの適用とoptionの設定
	//走行レコードの詳細を表示させるDOMのIDと
	//走行レコードのMapを表示させるDOMのIDを設定
	var options_record = {
		detailsId : "ui-showRecord-details",
		mapsId : "ui-showRecord-maps"
	};
	var $showRecord = $("#ui-showRecord-list > ul").showRecord(options_record);

	//保存した走行レコードの削除完了時によばれるカスタムイベントに対して処理を記述
	$showRecord.bind("record.deleted",function(){
		$slideView.slideView("backView");
	});

	//ランニング終了後の走行レコードの保存完了時によばれるカスタムイベントに対して処理を記述
	$showRecord.bind("record.saved",function(){
		$slideView.slideView("backView");
	});




/*---------------------- orientationchange ----------------------*/

	//画面回転時のサイズ計算処理用
	$(window).bind("orientationchange resize",function(){
		//各要素のheightの再計算/再設定
		adjustElementHeight();

		//iScroll
		window.iScrollElement.refresh();
 
		//ui-slideView
		$slideView.slideView("refresh");
	},false);
 
	//各要素のheightの再計算/再設定
	function adjustElementHeight(){
		var tabH = $tab[0].offsetHeight;
		var h = window.innerHeight - tabH;
		$("#container").css("height", h + "px");

		//Google Map表示領域のheight設定
		var headerH = $("#record section > header").eq(2)[0].offsetHeight;

		$showRecord.showRecord("refresh",h-headerH);
	}
	adjustElementHeight();

	//iScrollのスクロールが効くようにデフォルトのtouchmoveイベントをpreventDefault
	$(document).bind("touchmove",function(e){
		e.preventDefault();
	});

	//iScrollの適用
	iScrollElement = new iScroll("scroller");


});


