/*----------------------------------------------------------
 * ui-tab.js
 * author Ryuto Kurokawa
 * 
 *----------------------------------------------------------*/
$.widget("ui.tab",{
	options: {
		current: 0,
		contents: [],
		buttonsSelector: "ul>li",
		buttonsClassName: "ui-tab-buttons",
		currentButtonsClassName: "ui-tab-b-current",
		contentsClassName: "ui-tab-contents",
		currentContentsClassName: "ui-tab-c-current"
	},
	_create:function(){
		this.widgetEventPrefix = "tab.";
		return this;
	},
	_init:function(){
		//this.options.contents には表示を切り替える対象のセレクタを引数で受け取る
		var o = this.options;
		if(o.contents.length <= 0) return this;

		//タブメニューのボタンを変数に格納
		var $buttons = $(o.buttonsSelector,this.element);
		var _this = this;
		$.each(o.contents,function(i,v){
			//表示を切り替える対象のDOMにクラス名を追加
			$(v).addClass(o.contentsClassName);
			$buttons.eq(i)
				.addClass(o.buttonsClassName)
				.bind("click",{flg:i},$.proxy(_this._clickHandler,_this));
		});

		this.$buttons = $buttons.filter("." + o.buttonsClassName);
		this.$contents = $("." + o.contentsClassName);

		this.$contents.css("display","none");

		//初期表示の設定
		this.setCurrent(o.current);

		return this;
	},
	_clickHandler:function(e){
		//すでにアクティブになっているタブを選択した場合は処理を抜ける
		if(e.data.flg == this.options.current) return;
		this.setCurrent(e.data.flg);

		//表示切替後にカスタムイベントの発火
		this._trigger("changed",null,{flg:e.data.flg});

		
	},
	setCurrent: function(num){
		//引数には表示させたい要素のインデックスを受け取る
		var num = this.options.current = num;

		this.$buttons
			.filter("." + this.options.currentButtonsClassName)
			.removeClass(this.options.currentButtonsClassName);


		this.$contents
			.filter("." + this.options.currentContentsClassName)
			.removeClass(this.options.currentContentsClassName)
			.css("display","none");

		//表示させたい要素の表示と選択されたボタンに対してクラス名を追加
		this.$buttons.eq(num).addClass(this.options.currentButtonsClassName);
		this.$contents.eq(num).css("display","block").addClass(this.options.currentContentsClassName);
		
		return this;
	}
});


