// Sencha Touch
Ext.setup({

    // ホームスクリーンブックマークした時のアイコン
    icon: './img/icon.png',
    // アイコンに光沢をつける
    glossOnIcon: true,
    // ホームスクリーンブックマークから起動した時のスタートアップ画像
    phoneStartupScreen: './img/phone_startup.png',

    onReady: function(){

        // パネル1 (TOP画面)
        var panel1 = new Ext.Panel({

            fullscreen: true,

            layout: {
                type: 'vbox',
                pack: 'center'
            },

            items: [
                // TOP画像
                {html: '<img src="./img/title.png"></img>', width:320, height:80},
                // ボタン1(1P vs CPU)
                new Ext.Button({cls:'startBtn1', text:'先攻', width:'120px', height:'50px', handler:function(){panel2.show('fade'); }}), //ボタンが押されたらパネル2を表示させる
                // ボタン2(CPU vs 1P)
                new Ext.Button({cls:'startBtn2', text:'後攻', width:'120px', height:'50px', handler:function(){panel2.show('fade'); }}), //ボタンが押されたらパネル2を表示させる 
                // ボタン3(1P vs 2P)
                new Ext.Button({cls:'startBtn3', text:'対人戦',  width:'250px', height:'50px', handler:function(){panel2.show('fade'); }})  //ボタンが押されたらパネル2を表示させる 
            ]
        });

        // パネル2 (ゲーム画面、設定画面、アプリ説明画面を配置するタブパネル)
        var panel2 = new Ext.TabPanel({

            fullscreen: true,

            defaults: {
                iconMast: true,
                ui:       'plain'
            },
            
            // 画面上部にツールバーを追加
            dockedItems: new Ext.Toolbar({
                dock:  'top',
                title: 'Reversi',
                ui: 'light',
                items:[
                    // TOPボタンが押されたらpanel2を隠す
                    {text: 'TOP', handler:function(){panel2.hide();}},
                    {xtype: 'spacer'},
                    {iconMask: true, iconCls: 'refresh', handler:function(){}}
                ]
            }),

            // タブの設定
            tabBar: {
                dock:  'bottom',
                ui:    'light',
                layout: {pack:'center'}
            },

            // タブの切り替え方法(スライド)
            cardSwitchAnimation: {
                type: 'slide'
            },

            // 各ページの設定
            items: [
                {iconCls:'favorites', html:'ゲーム画面'},
                {iconCls:'settings',  html:'設定画面'},
                {iconCls:'info',      html:'アプリの説明画面'}
            ]

        });

        // 初期状態ではパネル2を隠して、パネル1を表示する。
        panel2.hide();
        panel1.show();
    }
});
